
include<dynamixel.scad>;

body_t = 3;
screw_d = 3;

module body_bot(positions) color("green") render() {
    t = body_t;
    d = 2 * dist(positions[0]);

    translate([ 0, 0, -XL320_hole_space / 2 - XL320_horn_h - body_t ]) {
        translate([ 0, 0, t ]) for (pos = positions) translate(pos)
            rotate([ 180, 0, 0 ]) difference() {
            XL320_horn_adapter(t);
            XL320_horn_hole_pos() { cylinder(d = 3, h = 100, center = true); }
        }

        tube(d - XL320_horn_d - t, d - XL320_horn_d + t, t);
        tube(d + XL320_horn_d - t, d + XL320_horn_d + t, t);
    }
}

module body_top(positions) color("green") render() {
    t = 3;
    d = 2 * dist(positions[0]);

    translate([ 0, 0, XL320_hole_space / 2 + XL320_horn_h ]) {
        for (pos = positions)
            translate(pos) render() tube(screw_d, screw_d + t * 2, t);

        tube(d - screw_d - t * 2, d - screw_d, t);
        tube(d + screw_d, d + screw_d + t * 2, t);
    }
}

module body_collision_a(positions) {
    d = 2 * dist(positions[0]) + XL320_horn_d + body_t;
    translate([ 0, 0, -XL320_hole_space / 2 - XL320_horn_h - body_t / 2 ])
        cube([ d, d, body_t ], center = true);
}

module body_collision_b(positions) {
    d = 2 * dist(positions[0]) + screw_d + body_t * 2;

    translate([ 0, 0, XL320_hole_space / 2 + XL320_horn_h + body_t / 2 ])
        cube([ d, d, body_t ], center = true);
}

module body(positions) {
    $fn = 32;
    body_bot(positions);

    body_top(positions);
}
