include<dynamixel.scad>;

screw_d = 3;

module coxa_holder(femurOffset) render() difference() {
    $fn = 32;

    space_r = sqrt(2) * XL320_dim[2] / 2;

    translate([ femurOffset[0] / 2, 0, 0 ]) cube(
        [ femurOffset[0], XL320_hole_space, XL320_hole_space ], center = true);

    for (p = [ [ 0, 0, 0 ], femurOffset ])
        translate(p) cube([ XL320_hole_x_offset * 2, 100, 100 ], center = true);

    XL320_aligned_hole_pos() {
        for (y = XL320_aligned_hole_offsets)
            translate([ 0, y, 0 ])
                cylinder(d = screw_d, h = 100, center = true);
    }
    translate(femurOffset) rotate([ 0, 0, 180 ]) rotate([ 90, 0, 0 ])
        XL320_aligned_hole_pos() {
        for (z = XL320_aligned_hole_offsets)
            translate([ 0, z, 0 ])
                cylinder(d = screw_d, h = 100, center = true);
    }
}

module coxa_collision(femurOffset) {
    dim = [
        femurOffset[0] + XL320_axis_offset * 2, XL320_dim[1] + XL320_horn_h,
        XL320_dim[2]
    ];
    translate([ 0, -XL320_horn_h / 2, 0 ]) translate(femurOffset / 2)
        cube(dim, center = true);
}

module coxa(femurOffset) {
    rotate([ 90, 0, 0 ]) {
        XL320();
        XL320_horn();
    }
    color("red") coxa_holder(femurOffset);
    translate(femurOffset) rotate([ 0, 180, 0 ]) {
        XL320();
        XL320_horn();
    }
}
