include<dynamixel.scad>;

module tibia_base(tipOffset) color("yellow") render() difference() {
    t = 2;
    a = XL320_hole_space;
    screw_d = 3;

    hull() {
        XL320_aligned_hole_pos() {
            for (z = XL320_aligned_hole_offsets)
                translate([ 0, 0, z ]) rotate([ 90, 0, 0 ])
                    cylinder(d = screw_d + t * 2, h = a, center = true);
        }

        translate(tipOffset) sphere(d = t);
    }
    difference() {
        union() {
            hull() {
                sphere(d = a);
                translate([ -t * 4, 0, 0 ]) translate(tipOffset) sphere(d = t);
            }

            rotate([ 0, 90, 0 ]) {
                for (an = [0:90:360]) rotate([ 0, 0, an ]) hull() {
                        translate([ t, 0, tipOffset[0] ]) sphere(d = t);
                        translate([ sqrt(2) * a / 2 + t, 0, 0 ])
                            cylinder(d = a, h = 200, center = true);
                    }
            }
        }
        XL320_aligned_hole_pos() for (z = [ -6, 6 ]) translate([ 0, 0, z ])
            rotate([ 90, 0, 0 ])
                cylinder(d = screw_d + t * 2, h = a, center = true);
    }

    XL320_aligned_hole_pos() {
        for (z = XL320_aligned_hole_offsets)
            translate([ 0, 0, z ]) rotate([ 90, 0, 0 ])
                cylinder(d = screw_d, h = 100, center = true);
    }
}

module tibia_collision(tipOffset) {
    z = XL320_dim[2];
    h = XL320_horn_h;
    y = XL320_dim[1];
    x_min = -XL320_axis_offset;
    x_max = x_min + XL320_dim[0];

    tip_x = dist(tipOffset) + 3;

    polyhedron(points =
                   [
                       [ x_min, -y / 2 - h, -z / 2 ], [ x_min, y / 2, -z / 2 ],
                       [ x_min, -y / 2 - h, z / 2 ], [ x_min, y / 2, z / 2 ],
                       [ x_max, -y / 2 - h, -z / 2 ], [ x_max, y / 2, -z / 2 ],
                       [ x_max, -y / 2 - h, z / 2 ], [ x_max, y / 2, z / 2 ],
                       [ tip_x, 0, 0 ]
                   ],
               faces = [
                   [ 0, 1, 3, 2 ], [ 0, 1, 5, 4 ], [ 0, 2, 6, 4 ],
                   [ 1, 3, 7, 5 ], [ 2, 3, 7, 6 ], [ 8, 4, 6 ], [ 8, 4, 5 ],
                   [ 8, 6, 7 ], [ 8, 7, 5 ]
               ]);
}

module tibia(tipOffset) {
    tibia_base(tipOffset);
    XL320();
    XL320_horn();
}
